=== debian/changelog ===
log4cxx (1.5.0-1) unstable; urgency=medium

  * New upstream release.
  * Drop patches d/p/{04,05}-cve-2025-54812* and d/p/06-cve-2025-54813*,
    as they are contained in the upstream version.

 -- Tobias Frost <tobi@debian.org>  Sat, 04 Oct 2025 20:39:12 +0200

log4cxx (1.4.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Security fixes for CVE-2025-54812 & CVE-2025-54813 from upstream:
    - d/p/{04,05}-cve-2025-54812*: (Closes: #1111879)
      + Escape any logger name '&' or '"' in html attribute data (PR#509)
      + Escape any thread name '&' or '"' in html attribute data (PR#514)
    - d/p/06-cve-2025-54813*: (Closes: #1111881)
      + Escape control characters in JSONLayout data (PR#512)

 -- Lukas Märdian <slyon@debian.org>  Sun, 28 Sep 2025 15:38:53 +0200
