=== debian/tests/control ===
Tests: build-tests
Depends: liblog4cxx-dev, @builddeps@, pkg-config, zip, default-jdk, liblog4j1.2-java
Restrictions: allow-stderr
